XMLEntityScanner (Xerces2 Implementation)
Keywords: org.apache.xerces.impl.XMLEntityScanner class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xerces.impl
Class XMLEntityScanner

    java.lang.Object
      org.apache.xerces.impl.XMLEntityScanner

All Implemented Interfaces:
  org.apache.xerces.xni.XMLLocator

Direct Known Subclasses:
  XML11EntityScanner

    public class XMLEntityScanner

extends java.lang.Object
implements org.apache.xerces.xni.XMLLocator

Implements the entity scanner methods.

Version:
  $Id: XMLEntityScanner.java 616011 2008-01-28 19:33:38Z mrglavas $
Author:
  Andy Clark, IBM, Neil Graham, IBM

# INTERNAL:

  Usage of this class is not supported. It may be altered or removed at any time.

Field Summary
`protected int` | `fBufferSize`
`protected XMLEntityManager.ScannedEntity` | `fCurrentEntity`
`protected XMLErrorReporter` | `fErrorReporter` Error reporter.
`protected SymbolTable` | `fSymbolTable`

Constructor Summary
`XMLEntityScanner()` Default constructor.

Method Summary
`java.lang.String` | `getBaseSystemId()` Returns the base system identifier of the currently scanned entity, or null if none is available.
`int` | `getCharacterOffset()` Returns the character offset where the current document event ends.
`int` | `getColumnNumber()` Returns the column number where the current document event ends.
`java.lang.String` | `getEncoding()` Returns the encoding of the current entity.
`java.lang.String` | `getExpandedSystemId()` Return the expanded system identifier for the current document event.
`int` | `getLineNumber()` Returns the line number where the current document event ends.
`java.lang.String` | `getLiteralSystemId()` Return the literal system identifier for the current document event.
`java.lang.String` | `getPublicId()` Return the public identifier for the current document event.
`java.lang.String` | `getXMLVersion()` Returns the XML version of the current entity.
`boolean` | `isExternal()` Returns true if the current entity being scanned is external.
`int` | `peekChar()` Returns the next character on the input.
`void` | `reset(SymbolTable symbolTable, XMLEntityManager entityManager, XMLErrorReporter reporter)`
`int` | `scanChar()` Returns the next character on the input.
`int` | `scanContent(org.apache.xerces.xni.XMLString content)` Scans a range of parsed character data, setting the fields of the XMLString structure, appropriately.
`boolean` | `scanData(java.lang.String delimiter, XMLStringBuffer buffer)` Scans a range of character data up to the specified delimiter, setting the fields of the XMLString structure, appropriately.
`int` | `scanLiteral(int quote, org.apache.xerces.xni.XMLString content)` Scans a range of attribute value data, setting the fields of the XMLString structure, appropriately.
`java.lang.String` | `scanName()` Returns a string matching the Name production appearing immediately on the input as a symbol, or null if no Name string is present.
`java.lang.String` | `scanNCName()` Returns a string matching the NCName production appearing immediately on the input as a symbol, or null if no NCName string is present.
`java.lang.String` | `scanNmtoken()` Returns a string matching the NMTOKEN production appearing immediately on the input as a symbol, or null if NMTOKEN Name string is present.
`boolean` | `scanQName(org.apache.xerces.xni.QName qname)` Scans a qualified name from the input, setting the fields of the QName structure appropriately.
`void` | `setBufferSize(int size)`
`void` | `setCurrentEntity(XMLEntityManager.ScannedEntity ent)`
`void` | `setEncoding(java.lang.String encoding)` Sets the encoding of the scanner.
`void` | `setXMLVersion(java.lang.String xmlVersion)` Sets the XML version.
`boolean` | `skipChar(int c)` Skips a character appearing immediately on the input.
`boolean` | `skipDeclSpaces()` Skips space characters appearing immediately on the input that would match non-terminal S (0x09, 0x0A, 0x0D, 0x20) before end of line normalization is performed.
`boolean` | `skipSpaces()` Skips space characters appearing immediately on the input.
`boolean` | `skipString(java.lang.String s)` Skips the specified string appearing immediately on the input.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### fCurrentEntity

    protected XMLEntityManager.ScannedEntity fCurrentEntity

### fSymbolTable

    protected SymbolTable fSymbolTable

### fBufferSize

    protected int fBufferSize

### fErrorReporter

    protected XMLErrorReporter fErrorReporter

  Error reporter. This property identifier is: http://apache.org/xml/properties/internal/error-reporter

Constructor Detail

### XMLEntityScanner

    public XMLEntityScanner()

  Default constructor.

Method Detail

### getBaseSystemId

    public final java.lang.String getBaseSystemId()

  Returns the base system identifier of the currently scanned entity, or null if none is available.

  Specified by:
    `getBaseSystemId` in interface `org.apache.xerces.xni.XMLLocator`

### setEncoding

    public final void setEncoding(java.lang.String encoding)
                           throws java.io.IOException

  Sets the encoding of the scanner. This method is used by the scanners if the XMLDecl or TextDecl line contains an encoding pseudo-attribute.

  Note: The underlying character reader on the current entity will be changed to accomodate the new encoding. However, the new encoding is ignored if the current reader was not constructed from an input stream (e.g. an external entity that is resolved directly to the appropriate java.io.Reader object).

  Parameters:
    `encoding` - The IANA encoding name of the new encoding.
  Throws:
    `java.io.IOException` - Thrown if the new encoding is not supported.
  See Also:
    `EncodingMap`

### setXMLVersion

    public final void setXMLVersion(java.lang.String xmlVersion)

  Sets the XML version. This method is used by the scanners to report the value of the version pseudo-attribute in an XML or text declaration.

  Parameters:
    `xmlVersion` - the XML version of the current entity

### isExternal

    public final boolean isExternal()

  Returns true if the current entity being scanned is external.

### peekChar

    public int peekChar()
                 throws java.io.IOException

  Returns the next character on the input.

  Note: The character is not consumed.

  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.

### scanChar

    public int scanChar()
                 throws java.io.IOException

  Returns the next character on the input.

  Note: The character is consumed.

  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.

### scanNmtoken

    public java.lang.String scanNmtoken()
                                 throws java.io.IOException

  Returns a string matching the NMTOKEN production appearing immediately on the input as a symbol, or null if NMTOKEN Name string is present.

  Note: The NMTOKEN characters are consumed.

  Note: The string returned must be a symbol. The SymbolTable can be used for this purpose.

  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.
  See Also:
    `SymbolTable`, `XMLChar.isName(int)`

### scanName

    public java.lang.String scanName()
                              throws java.io.IOException

  Returns a string matching the Name production appearing immediately on the input as a symbol, or null if no Name string is present.

  Note: The Name characters are consumed.

  Note: The string returned must be a symbol. The SymbolTable can be used for this purpose.

  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.
  See Also:
    `SymbolTable`, `XMLChar.isName(int)`, `XMLChar.isNameStart(int)`

### scanNCName

    public java.lang.String scanNCName()
                                throws java.io.IOException

  Returns a string matching the NCName production appearing immediately on the input as a symbol, or null if no NCName string is present.

  Note: The NCName characters are consumed.

  Note: The string returned must be a symbol. The SymbolTable can be used for this purpose.

  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.
  See Also:
    `SymbolTable`, `XMLChar.isNCName(int)`, `XMLChar.isNCNameStart(int)`

### scanQName

    public boolean scanQName(org.apache.xerces.xni.QName qname)
                      throws java.io.IOException

  Scans a qualified name from the input, setting the fields of the QName structure appropriately.

  Note: The qualified name characters are consumed.

  Note: The strings used to set the values of the QName structure must be symbols. The SymbolTable can be used for this purpose.

  Parameters:
    `qname` - The qualified name structure to fill.
  Returns:
    Returns true if a qualified name appeared immediately on the input and was scanned, false otherwise.
  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.
  See Also:
    `SymbolTable`, `XMLChar.isName(int)`, `XMLChar.isNameStart(int)`

### scanContent

    public int scanContent(org.apache.xerces.xni.XMLString content)
                    throws java.io.IOException

  Scans a range of parsed character data, setting the fields of the XMLString structure, appropriately.

  Note: The characters are consumed.

  Note: This method does not guarantee to return the longest run of parsed character data. This method may return before markup due to reaching the end of the input buffer or any other reason.

  Note: The fields contained in the XMLString structure are not guaranteed to remain valid upon subsequent calls to the entity scanner. Therefore, the caller is responsible for immediately using the returned character data or making a copy of the character data.

  Parameters:
    `content` - The content structure to fill.
  Returns:
    Returns the next character on the input, if known. This value may be -1 but this does note designate end of file.
  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.

### scanLiteral

    public int scanLiteral(int quote,
                           org.apache.xerces.xni.XMLString content)
                    throws java.io.IOException

  Scans a range of attribute value data, setting the fields of the XMLString structure, appropriately.

  Note: The characters are consumed.

  Note: This method does not guarantee to return the longest run of attribute value data. This method may return before the quote character due to reaching the end of the input buffer or any other reason.

  Note: The fields contained in the XMLString structure are not guaranteed to remain valid upon subsequent calls to the entity scanner. Therefore, the caller is responsible for immediately using the returned character data or making a copy of the character data.

  Parameters:
    `quote` - The quote character that signifies the end of the attribute value data.
    `content` - The content structure to fill.
  Returns:
    Returns the next character on the input, if known. This value may be -1 but this does note designate end of file.
  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.

### scanData

    public boolean scanData(java.lang.String delimiter,
                            XMLStringBuffer buffer)
                     throws java.io.IOException

  Scans a range of character data up to the specified delimiter, setting the fields of the XMLString structure, appropriately.

  Note: The characters are consumed.

  Note: This assumes that the internal buffer is at least the same size, or bigger, than the length of the delimiter and that the delimiter contains at least one character.

  Note: This method does not guarantee to return the longest run of character data. This method may return before the delimiter due to reaching the end of the input buffer or any other reason.

  Note: The fields contained in the XMLString structure are not guaranteed to remain valid upon subsequent calls to the entity scanner. Therefore, the caller is responsible for immediately using the returned character data or making a copy of the character data.

  Parameters:
    `delimiter` - The string that signifies the end of the character data to be scanned.
    `buffer` - The XMLStringBuffer to fill.
  Returns:
    Returns true if there is more data to scan, false otherwise.
  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.

### skipChar

    public boolean skipChar(int c)
                     throws java.io.IOException

  Skips a character appearing immediately on the input.

  Note: The character is consumed only if it matches the specified character.

  Parameters:
    `c` - The character to skip.
  Returns:
    Returns true if the character was skipped.
  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.

### skipSpaces

    public boolean skipSpaces()
                       throws java.io.IOException

  Skips space characters appearing immediately on the input.

  Note: The characters are consumed only if they are space characters.

  Returns:
    Returns true if at least one space character was skipped.
  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.
  See Also:
    `XMLChar.isSpace(int)`

### skipDeclSpaces

    public final boolean skipDeclSpaces()
                                 throws java.io.IOException

  Skips space characters appearing immediately on the input that would match non-terminal S (0x09, 0x0A, 0x0D, 0x20) before end of line normalization is performed. This is useful when scanning structures such as the XMLDecl and TextDecl that can only contain US-ASCII characters.

  Note: The characters are consumed only if they would match non-terminal S before end of line normalization is performed.

  Returns:
    Returns true if at least one space character was skipped.
  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.
  See Also:
    `XMLChar.isSpace(int)`

### skipString

    public boolean skipString(java.lang.String s)
                       throws java.io.IOException

  Skips the specified string appearing immediately on the input.

  Note: The characters are consumed only if they are space characters.

  Parameters:
    `s` - The string to skip.
  Returns:
    Returns true if the string was skipped.
  Throws:
    `java.io.IOException` - Thrown if i/o error occurs.
    `java.io.EOFException` - Thrown on end of file.

### getPublicId

    public final java.lang.String getPublicId()

  Return the public identifier for the current document event.

  The return value is the public identifier of the document entity or of the external parsed entity in which the markup triggering the event appears.

  Specified by:
    `getPublicId` in interface `org.apache.xerces.xni.XMLLocator`
  Returns:
    A string containing the public identifier, or null if none is available.

### getExpandedSystemId

    public final java.lang.String getExpandedSystemId()

  Return the expanded system identifier for the current document event.

  The return value is the expanded system identifier of the document entity or of the external parsed entity in which the markup triggering the event appears.

  If the system identifier is a URL, the parser must resolve it fully before passing it to the application.

  Specified by:
    `getExpandedSystemId` in interface `org.apache.xerces.xni.XMLLocator`
  Returns:
    A string containing the expanded system identifier, or null if none is available.

### getLiteralSystemId

    public final java.lang.String getLiteralSystemId()

  Return the literal system identifier for the current document event.

  The return value is the literal system identifier of the document entity or of the external parsed entity in which the markup triggering the event appears.

  Specified by:
    `getLiteralSystemId` in interface `org.apache.xerces.xni.XMLLocator`
  Returns:
    A string containing the literal system identifier, or null if none is available.

### getLineNumber

    public final int getLineNumber()

  Returns the line number where the current document event ends.

  Warning: The return value from the method is intended only as an approximation for the sake of error reporting; it is not intended to provide sufficient information to edit the character content of the original XML document.

  The return value is an approximation of the line number in the document entity or external parsed entity where the markup triggering the event appears.

  If possible, the line position of the first character after the text associated with the document event should be provided. The first line in the document is line 1.

  Specified by:
    `getLineNumber` in interface `org.apache.xerces.xni.XMLLocator`
  Returns:
    The line number, or -1 if none is available.

### getColumnNumber

    public final int getColumnNumber()

  Returns the column number where the current document event ends.

  Warning: The return value from the method is intended only as an approximation for the sake of error reporting; it is not intended to provide sufficient information to edit the character content of the original XML document.

  The return value is an approximation of the column number in the document entity or external parsed entity where the markup triggering the event appears.

  If possible, the line position of the first character after the text associated with the document event should be provided. The first column in each line is column 1.

  Specified by:
    `getColumnNumber` in interface `org.apache.xerces.xni.XMLLocator`
  Returns:
    The column number, or -1 if none is available.

### getCharacterOffset

    public final int getCharacterOffset()

  Returns the character offset where the current document event ends.

  Warning: The return value from the method is intended only as an approximation for the sake of error reporting; it is not intended to provide sufficient information to edit the character content of the original XML document.

  The return value is an approximation of the character offset in the document entity or external parsed entity where the markup triggering the event appears.

  If possible, the character offset of the first character after the text associated with the document event should be provided.

  Specified by:
    `getCharacterOffset` in interface `org.apache.xerces.xni.XMLLocator`
  Returns:
    The character offset, or -1 if none is available.

### getEncoding

    public final java.lang.String getEncoding()

  Returns the encoding of the current entity. Note that, for a given entity, this value can only be considered final once the encoding declaration has been read (or once it has been determined that there is no such declaration) since, no encoding having been specified on the XMLInputSource, the parser will make an initial "guess" which could be in error.

  Specified by:
    `getEncoding` in interface `org.apache.xerces.xni.XMLLocator`

### getXMLVersion

    public final java.lang.String getXMLVersion()

  Returns the XML version of the current entity. This will normally be the value from the XML or text declaration or defaulted by the parser. Note that that this value may be different than the version of the processing rules applied to the current entity. For instance, an XML 1.1 document may refer to XML 1.0 entities. In such a case the rules of XML 1.1 are applied to the entire document. Also note that, for a given entity, this value can only be considered final once the XML or text declaration has been read or once it has been determined that there is no such declaration.

  Specified by:
    `getXMLVersion` in interface `org.apache.xerces.xni.XMLLocator`

### setCurrentEntity

    public final void setCurrentEntity(XMLEntityManager.ScannedEntity ent)

### setBufferSize

    public final void setBufferSize(int size)

### reset

    public final void reset(SymbolTable symbolTable,
                            XMLEntityManager entityManager,
                            XMLErrorReporter reporter)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.